define([
		"../spells/spells",
		"../classes/classes"],
		function(Spells, Classes){

	var Character = function(options){

		//console.log(new Spells, "list of spells");
		//console.log(new Classes, "list of classes");

	};

	Character.prototype = {

		_Initialize : function(){

			console.log("Greetings, i am", this._toJSON().personal.name, "[level", this._toJSON().personal.level+",", this._toJSON().personal.class+"]");

			console.log(this);
			console.log(this._toJSON());

			this._SetGraphics();

			this._AddEvents();

			return this;

		},

		_GeneralConfigs : {

			globalCooldown : {

				isActive 	: false,
				duration 	: 1

			}

		},

		Automator : function(moves){

			var move = 0,
				self = this;

			function doActions(){

				console.log("im dancing");

				moves[move](self);

				setTimeout(function(){

					if (move < moves.length)
					{
						doActions();
						move++;

					};

				}, 90);
			}

			doActions();

		},

		Dance : function(){

			var moves = [this.Moviments.Crouch, this.Moviments.Normal, this.Moviments.Crouch, this.Moviments.Normal, this.Moviments.Crouch, this.Moviments.Normal, this.Moviments.Crouch, this.Moviments.Normal, this.Moviments.Crouch, this.Moviments.Normal, this.Moviments.Crouch, this.Moviments.Normal, this.Moviments.WalkRight, this.Moviments.WalkLeft, this.Moviments.WalkRight, this.Moviments.WalkLeft, this.Moviments.WalkRight, this.Moviments.WalkLeft, this.Moviments.LookUp, this.Moviments.Normal, this.Moviments.LookUp, this.Moviments.Normal, this.Moviments.LookUp, this.Moviments.Normal, this.Moviments.LookUp, this.Moviments.Normal, this.Moviments.WalkRight, this.Moviments.Normal,this.Moviments.LookUp];

			this.Automator(moves);

		},

		_SetGraphics : function(){

			this.posX = 0;
			this.step = 0;

		},

											/* EVENTS */
		_AddEvents : function(){

			var self = this;

			document.addEventListener("keyup", function(e){

				self.Moviments.Normal(self);

			});

			document.addEventListener("keydown", function(e){

				//console.log(e.keyCode);

				switch(e.keyCode){

					case 68:
					case 39:

						self.Moviments.WalkRight(self);

					break;

					case 65:
					case 37:

						self.Moviments.WalkLeft(self);

					break;

					case 87:
					case 38:

						self.Moviments.LookUp(self);

					break;

					case 83:
					case 40:

						self.Moviments.Crouch(self);

					break;

					case 32:

						self.Moviments.Jump(self);

					break;

					//Spell Cast
					case 49:

						self.Actionbar.a(self);

					break;

					case 50:

						self.Actionbar.b(self);

					break;

					case 51:

						self.Actionbar.c(self);

					break;

				}

			}, false);

		},

		Actionbar : {

			a : function(self){

				self.Cast(0);

			},

			b : function(self){

				self.Cast(1);

			},

			c : function(self){

				self.Cast(2);
			}

		},

		Moviments : {

			LookUp : function(self){

				console.log("im looking up..");
				self.sprite.style.backgroundPosition = "-128px 0px";

			},

			WalkRight : function(self){

				self.sprite.style.webkitTransform = 'scaleX(1)'

				var matrix = ["-255px 128px", "128px 0px", "130px 0px", "0px 255px", "-128px 255px", "-255px 255px", "-380px 255px", "0px 128px", "-128px 128px", "-255px 128px"];

				console.log("walking right", self.sprite);

				self.posX = self.posX + 10;

				self.sprite.style.left = self.posX;
				self.sprite.style.backgroundPosition = matrix[self.step];

				self.step++;

				if (self.step >= matrix.length)
					self.step = 0;

				//self.context.getImageData();

			},

			WalkLeft : function(self){

				self.sprite.style.webkitTransform = 'scaleX(-1)'

				var matrix = [ "-255px 128px", "128px 0px", "130px 0px", "0px 255px", "-128px 255px", "-255px 255px", "-380px 255px", "0px 128px", "-128px 128px", "-255px 128px"];

				console.log("walking Left", self.sprite);

				self.posX = self.posX - 10;

				self.sprite.style.left = self.posX;
				self.sprite.style.backgroundPosition = matrix[self.step];

				self.step++;

				if (self.step >= matrix.length)
					self.step = 0;

			},

			Crouch : function(self){

				console.log("im crouching..");

				self.sprite.style.backgroundPosition = "260px 0px";

			},

			Jump : function(self){

				console.log("im jumping..");

			},

			Normal : function(self){

				self.sprite.style.backgroundPosition = "0px 0px";
				self.step = 0;
			}

		},

		isCasting : false,

		Cast : function(input){

			if ((this._toJSON().skills[input]) && (!this.isCasting) && (!this._GeneralConfigs.globalCooldown.isActive)) {

				var spell 	= this._toJSON().skills[input],
					self 	= this;

					this._GeneralConfigs.globalCooldown.isActive = true;

					window.setTimeout(function(){

						self._GeneralConfigs.globalCooldown.isActive = false;

					}, this._GeneralConfigs.globalCooldown.duration*1000);

					if (spell.cast > 0){

						console.log("--casting--");

						this.isCasting = true;

						window.setTimeout(function(){

							self.SortSpellType(spell);
							self.isCasting = false;

						}, spell.cast*1000);

					}else{

						this.SortSpellType(spell);

					}

			}else{

				console.log("I am not ready yet..");

			}

		},

		Spell : {

			Attack : function(spell, self){

				var damage 		= spell.effect.damage.amount,
					maxRange 	= 1.15 + (self.attributes[self.class.primaryAtribute]*0.15) * (self.level*0.025),
					minRange 	= 0.55 + (self.attributes[self.class.primaryAtribute]*0.15) * (self.level*0.015);

					damage = Math.floor(Math.random() * ((damage*maxRange) - (damage*minRange)) + (damage*minRange));

					self._CastingLog(spell, damage);

				return damage;

			},

			Heal : function(spell, self){

				var heal 		= spell.effect.heal.amount,
					maxRange 	= 1.15 + (self.attributes[self.class.primaryAtribute]*0.15) * (self.level*0.025),
					minRange 	= 0.55 + (self.attributes[self.class.primaryAtribute]*0.15) * (self.level*0.015);

					heal = Math.floor(Math.random() * ((heal*maxRange) - (heal*minRange)) + (heal*minRange));


					self._CastingLog(spell, heal);

				return heal;
			},

			Buff : function(spell, self){

				self._CastingLog(spell, self);

			}

		},

		SortSpellType : function(spell){

			if (spell.effect.hasOwnProperty("damage"))
			{

				this.Spell.Attack(spell, this);

			};

			if (spell.effect.hasOwnProperty("heal"))
			{

				this.Spell.Heal(spell, this);

			};

			if (spell.effect.hasOwnProperty("buff"))
			{

				this.Spell.Buff(spell, this);

			};

		},

		LevelUp : function(){

			this.level++;

			console.log("DING!!! Your are now level", this.level);

			for(var attr in this.attributes){

				this.attributes[attr] = Math.floor(this.attributes[attr] * 1.05);

			};

			console.log(this.attributes);

		},

		LevelDown : function(){


		},
												/* EVENTS END */
												/* UTILS */

		_CastingLog : function(spell, effect){

			if (spell.effect.hasOwnProperty("damage")){

				console.log(this._toJSON().personal.name,"casted", spell.name,"dealing",effect,"damage.");

			};

			if (spell.effect.hasOwnProperty("heal")){

				console.log(this._toJSON().personal.name,"healed for",effect,".");

			};

			if (spell.effect.hasOwnProperty("buff"))
			{

				console.log("buffed himself with",spell.name,".");

			};

		},

		_toJSON : function(){

			var result = {

					personal : {

						name 	: this.name,
						level 	: this.level,
						title 	: this.title,
						class 	: this.class.name

					},

					attributes : this.attributes,

					skills : this.class.skills.powers

			};

			return result;
		},

		_objectSize : function(obj){

			var size = 0;

			for(var attr in obj){

				if (this._GetAttr(attr, obj))
						size++
			};

			return size;

		},

		_CheckAttr : function(attr, obj){

			if (obj.hasOwnProperty(attr))
					return attr;

		},

		_SetRandomName : function(){

			var listOfNames = [

					"Kevis",
					"John",
					"Arthur",
					"Francis",
					"Brandon"
			];

			var sort = Math.floor((Math.random()*listOfNames.length-1) + 1);

			return listOfNames[sort];

		},
												/* UTILS END */

												/* STATS */
		_DefineBase : function(properties){

			this.sprite = document.getElementById("player"+properties.idNode);

			this.name 	= properties.name 	|| this._SetRandomName();
			this.level 	= properties.level 	|| 1;
			this.class 	= this._DefineClasses();

			return this;

		},

		_DefineAttributes : function(){

			this.attributes = {

				health 		: 157,
				intelect 	: 28,
				stamina 	: 33,
				strength 	: 37,
				defense 	: 51,
				armor 		: 127,
				damage 		: 43

			};

			return this;

		},

		_DefineClasses : function(){

			var listOfClasses 	= ["warrior", "mage", "shaman"],
				sort 			= Math.floor((Math.random()*listOfClasses.length-1) + 1);

			return Classes._DefineClass(listOfClasses[sort]);

		}

													/* STATS END */
	}

	return Character;

});
